> For the complete documentation index, see [llms.txt](https://docs.kaedim3d.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.kaedim3d.com/enterprise-features/custom-integrations/apis/web-hooks.md).

# Web Hooks

Creating a webhook endpoint is the same as creating any other page on your website. It’s an HTTP or HTTPS endpoint on your server with a URL. Please ensure that your endpoint is HTTPS when setting it up.

Set up an HTTP endpoint on your server that can accept webhook requests with a POST method. For example, this URL route in Flask maps to a Python webhook function: How do I receive webhook data?

1. Authenticate a user (Authentication Flow)
2. Make sure your webhook URL is correct

🎉 That’s it!

## Webhook Signing

Kaedim will, in all requests made to your webhook, include a header kaedim-signature, which will contain a hash value unique to the request and developer ID.

The signature secret - KAEDIM SECRET - can be found in user settings next to your developer ID and API-key and can be reset at any time.

Make sure to use utf-8 encoding for the payload, and to use HEX digest for the hashing function

{% hint style="info" %}
*Example of a Node.js signature verification:*
{% endhint %}

```javascript
const secret = "Api-Secret"; 
const payload = JSON.stringify(response.body);
console.log(response.body.result);
const devID = response.body.results.devID;
const signature = JSON.parse(response.headers["kaedim-signature"]);
/* {
  t : 1235678,
  v1:80e62bdd6bddf54905d3cd6e13940626e16aedd....
}*/
const checkSignature = crypto
  .createHmac("sha256", secret)
  .update(`${signature.t}${payload}`)
  .digest("hex");

if (
    crypto.timingSafeEqual(
      Buffer.from(signature.v1),
      Buffer.from(checkSignature)
    )
  ) {
    // Authenticity confirmed
    console.log("SUCCESS");
  } else {
    // Reject response
    console.log("FAIL");
  }
```

Your endpoint will receive requests. These will have a type that can be sculpt, generation, unwrap, texture, rig, or lod. It will also have a status that can be new, completed, approved, dismissed, or uploaded. There will also be two boolean flags isRevision and assetComplete.\\

{% hint style="info" %}
*Example webhook request:*
{% endhint %}

<pre class="language-json"><code class="lang-json">{
  results: {
    status: 'uploaded',
    userID: '94d... ',
    studioID: null,
    requestID: '927... ',
    iterationID: 2,
    name: '',
    image: 'https://... ',
    type: 'generation',
    isRevision: false,
    createdAt: '2025-02-22T05:49:57.000Z',
<strong>    completedAt: null,
</strong>    assetComplete: false,
    completedModels: {
      fbx: 'https://... ',
      glb: 'https://... ',
      mtl: 'https://... ',
      obj: 'https://... ',
      usd: 'https://... ',
      gltf: 'https://... ',
    },
    devID: '94d... '
  }
}
</code></pre>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.kaedim3d.com/enterprise-features/custom-integrations/apis/web-hooks.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
